<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>29.10</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css" rel="stylesheet"/>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js"></script>
    <script>
        const fetchAPI = (url, options) => {
            fetch(url, options) // Promise
                // Callback đầu tiên sẽ trả về reponse => Nhiệm vụ cần chuyển thành json để xử lý
                .then((res) => {
                    return res.json();
                })
                .then((data) => {
                    console.log(data);
                    // Xử lý tiếp data tại đây
                })
                // Bắt lỗi - chỉ dùng 1 lần
                .catch((error) => {
                    console.error(error);
                })
        }

        const getAllBtn = () => {
            console.log("GET ALL BUTTON");

            var uRL = "https://jsonplaceholder.typicode.com/posts";
            var options = {
                method: "GET"
            }

            fetchAPI(uRL, options);
        }

        const getByIDBtn = () => {
            console.log("GET BY ID BUTTON");

            var uRL = "https://jsonplaceholder.typicode.com/posts/1";
            var options = {
                method: "GET"
            }

            fetchAPI(uRL, options);
        }
        const createBtn = () => {
            console.log("CREATE BUTTON");

            var uRL = "https://jsonplaceholder.typicode.com/posts";
            var options = {
                method: "POST",
                body: JSON.stringify(
                    { title: 'foo', body: 'bar', userId: 1 }
                ),
                headers: {
                    "Content-Type": "application/json"
                }
            }

            fetchAPI(uRL, options);
        }
        const updateBtn = () => {
            console.log("UPDATE BUTTON");

            var uRL = "https://jsonplaceholder.typicode.com/posts/1";
            var options = {
                method: "PUT",
                body: JSON.stringify(
                    { title: 'foo', body: 'bar', userId: 1 }
                ),
                headers: {
                    "Content-Type": "application/json"
                }
            }

            fetchAPI(uRL, options);
        }
        const deleteBtn = () => {
            console.log("DELETE BUTTON");

            var uRL  = "https://jsonplaceholder.typicode.com/posts/1";
            var options = {
                method: "DELETE"
            }

            fetchAPI(uRL, options);
        }
    </script>
</head>
<body>
    <div class="container mt-5">
        <button class="btn btn-info" onclick="getAllBtn()">Get All</button>
        <button class="btn btn-primary" onclick="getByIDBtn()">Get By ID</button>
        <button class="btn btn-success" onclick="createBtn()">Create</button>
        <button class="btn btn-danger" onclick="updateBtn()">Update</button>
        <button class="btn btn-warning" onclick="deleteBtn()">Delete</button>
    </div>
</body>
</html>